/********************************************************************\

  Name:         camnull.h
  Created by:   Stefan Ritt

  Cotents:      CAMAC dummy functions for test purposes

  Revision history
  ------------------------------------------------------------------
  date        by    modification
  ---------   ---   ------------------------------------------------
  03-MAR-98   SR    created

\********************************************************************/

/*------------------------------------------------------------------*/

#define CAMO(n,a,f,d) (d)
#define CAMI(n,a,f,d) *(d) = 1
#define CAMI24(n,a,f,d) *(d) = 1
#define CAMIQ(n,a,f,d,x,q)   { *(d) = 1; *x = 1; *q = 1; }
#define CAMIQ24(n,a,f,d,x,q) { *(d) = 1; *x = 1; *q = 1; }
#define CAMQ(n,a,f,q)        { *q = 1; }
#define CAML(d)              { *d = 1; }

#define CAMAC_INIT() 
#define CAMAC_SET_INHIBIT()
#define CAMAC_CLEAR_INHIBIT()
#define CAMAC_C_CYCLE()
#define CAMAC_Z_CYCLE()
#define CAMAC_LAM_ENABLE(n)
#define CAMAC_LAM_RESET()

#define CAM_INTERRUPT_ATTACH(isr)
#define CAM_INTERRUPT_DETACH()
#define CAM_INTERRUPT_ENABLE()
#define CAM_INTERRUPT_DISABLE()

/*------------------------------------------------------------------*/

#define CAMAC_TEST void camo(n,a,f,d)  \
{ CAMO(n,a,f,d); }                     \
void cami(n,a,f) {                     \
  unsigned long d,x,q;                 \
  CAMIQ(n,a,f,&d,&x,&q);               \
  printf("d=%lX,X=%d,Q=%d\n",d,x,q); } \
void set_inhibit(void)                 \
{ *((unsigned long *) 0xC0E7A4) = 0; } \
void clear_inhibit(void)               \
{ *((unsigned long *) 0xC0C7A4) = 0; } \
void c_cycle(void)                     \
{ *((unsigned long *) 0xC0D724) = 0; } \
void z_cycle(void)                     \
{ *((unsigned long *) 0xC0D720) = 0; } 

/*------------------------------------------------------------------*/
