/*-----------------------------------------------------------------------------
 *  Copyright (c) 1998      TRIUMF Data Acquistion Group
 *  Please leave this header in any reproduction of that distribution
 * 
 *  TRIUMF Data Acquisition Group, 4004 Wesbrook Mall, Vancouver, B.C. V6T 2A3
 *  Email: online@triumf.ca           Tel: (604) 222-1047  Fax: (604) 222-1074
 *         amaudruz@triumf.ca
 * -----------------------------------------------------------------------------
 *  
 *  Description	: Midas Camac Standard calls. 
 *  Requires 	: 
 *  Application : Used in any camac driver
 *  Author:  Pierre-Andre Amaudruz Data Acquisition Group
 *  Revision 1.0  1998        Pierre	 Initial revision
 *---------------------------------------------------------------------------*/

#ifndef INLINE
#if defined( _MSC_VER )
#define INLINE __inline
#elif defined(__GNUC__)
#define INLINE __inline__
#else 
#define INLINE
#endif
#endif

#define EXTERNAL extern 

#ifndef MIDAS_TYPE_DEFINED
#define MIDAS_TYPE_DEFINED

typedef unsigned short int WORD;

#ifdef __alpha
typedef unsigned int       DWORD;
#else
typedef unsigned long int  DWORD;
#endif

#endif /* MIDAS_TYPE_DEFINED */

/*------------------------------------------------------------------*/

EXTERNAL INLINE void cam16i   (const int c, const int n, const int a, const int f, WORD *d);
EXTERNAL INLINE void cam24i   (const int c, const int n, const int a, const int f, DWORD *d);
EXTERNAL INLINE void cam16i_q (const int c, const int n, const int a, const int f, WORD *d, int *x, int *q);
EXTERNAL INLINE void cam24i_q (const int c, const int n, const int a, const int f, DWORD *d, int *x, int *q);
EXTERNAL INLINE void cam16i_r (const int c, const int n, const int a, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24i_r (const int c, const int n, const int a, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16i_rq(const int c, const int n, const int a, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24i_rq(const int c, const int n, const int a, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16i_sa(const int c, const int n, const int a, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24i_sa(const int c, const int n, const int a, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16i_sn(const int c, const int n, const int a, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24i_sn(const int c, const int n, const int a, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cami     (const int c, const int n, const int a, const int f, WORD *d);
EXTERNAL INLINE void cam16o   (const int c, const int n, const int a, const int f, WORD  d);
EXTERNAL INLINE void cam24o   (const int c, const int n, const int a, const int f, DWORD  d);
EXTERNAL INLINE void cam16o_q (const int c, const int n, const int a, const int f, WORD d, int *x, int *q);
EXTERNAL INLINE void cam24o_q (const int c, const int n, const int a, const int f, DWORD d, int *x, int *q);
EXTERNAL INLINE void cam16o_r (const int c, const int n, const int a, const int f, WORD *d, const int r);
EXTERNAL INLINE void cam24o_r (const int c, const int n, const int a, const int f, DWORD *d, const int r);
EXTERNAL INLINE void camo     (const int c, const int n, const int a, const int f, WORD d);
EXTERNAL INLINE int  camc_chk (const int c);
EXTERNAL INLINE void camc     (const int c, const int n, const int a, const int f);
EXTERNAL INLINE void camc_q   (const int c, const int n, const int a, const int f, int *q);
EXTERNAL INLINE void camc_sa  (const int c, const int n, const int a, const int f, const int r);
EXTERNAL INLINE void camc_sn  (const int c, const int n, const int a, const int f, const int r);
EXTERNAL INLINE int  cam_init (void);
EXTERNAL INLINE int  cam_init_rpc(char *host_name, char *exp_name, char *client_name, char *rpc_server);
EXTERNAL INLINE void cam_exit (void);
EXTERNAL INLINE void cam_inhibit_set  (const int c);
EXTERNAL INLINE void cam_inhibit_clear(const int c);
EXTERNAL INLINE void cam_crate_clear  (const int c);
EXTERNAL INLINE void cam_crate_zinit  (const int c);
EXTERNAL INLINE void cam_lam_enable   (const int c, const int n);
EXTERNAL INLINE void cam_lam_disable  (const int c, const int n);
EXTERNAL INLINE void cam_lam_read     (const int c, int *lam);
EXTERNAL INLINE void cam_lam_clear    (const int c, const int n);
EXTERNAL INLINE void came_cn   (int *ext, const int b, const int c, const int n, const int a);
EXTERNAL INLINE void came_ext  (const int ext, int *b, int *c, int *n, int *a);
EXTERNAL INLINE void cam16ei   (const int ext, const int f, WORD *d);
EXTERNAL INLINE void cam24ei   (const int ext, const int f, DWORD *d);
EXTERNAL INLINE void cam16ei_r (const int ext, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24ei_r (const int ext, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16ei_q (const int ext, const int f, WORD *d, int *x, int *q);
EXTERNAL INLINE void cam24ei_q (const int ext, const int f, DWORD *d, int *x, int *q);
EXTERNAL INLINE void cam16eo_q (const int ext, const int f, WORD d, int *x, int *q);
EXTERNAL INLINE void cam24eo_q (const int ext, const int f, DWORD d, int *x, int *q);
EXTERNAL INLINE void cam16ei_rq(const int ext, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24ei_rq(const int ext, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16ei_sa(const int ext, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24ei_sa(const int ext, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16ei_sn(const int ext, const int f, WORD **d, const int r);
EXTERNAL INLINE void cam24ei_sn(const int ext, const int f, DWORD **d, const int r);
EXTERNAL INLINE void cam16eo   (const int ext, const int f, WORD d);
EXTERNAL INLINE void cam24eo   (const int ext, const int f, DWORD d);
EXTERNAL INLINE void camec     (const int ext, const int f);
EXTERNAL INLINE void camec_q   (const int ext, const int f, int *x, int *q);
EXTERNAL INLINE void camec_sa  (const int ext, const int f, const int r);
EXTERNAL INLINE void camec_sn  (const int ext, const int f, const int r);
EXTERNAL INLINE void cam_interrupt_enable (void);
EXTERNAL INLINE void cam_interrupt_disable(void);
EXTERNAL INLINE void cam_interrupt_attach (void (*isr)());
EXTERNAL INLINE void cam_interrupt_detach (void);
EXTERNAL INLINE void cam_glint_enable     (void);
EXTERNAL INLINE void cam_glint_disable    (void);
EXTERNAL INLINE void cam_glint_attach     (int lam, void (*isr)());
EXTERNAL INLINE void cam_glint_detach();
