/********************************************************************\

  Name:         camnull.h
  Created by:   Stefan Ritt

  Cotents:      CAMAC dummy functions for test purposes

  Revision history
  ------------------------------------------------------------------
  date        by    modification
  ---------   ---   ------------------------------------------------
  03-MAR-98   SR    created

\********************************************************************/

/*------------------------------------------------------------------*/

/*
   macro                purpose

   CAMO                 32 bit output
   CAMI                 16 bit input
   CAMI32               32 bit input
   CAMIQ                16 bit input with X and Q
   CAMIQ32              32 bit input with X and Q

   CAMAC_SET_INHIBIT
   CAMAC_CLEAR_INHIBIT
   CAMAC_C_CYCLE
   CAMAC_Z_CYCLE
   CAMAC_LAM_ENABLE
   CAMAC_LAM_DISABLE
   CAMAC_SET_LAM_BIT(station)             set mask bit for station
   CAMAC_CLEAR_LAM_BIT(station)           clear mask bit for station
   CAMAC_READ_LAM()                       read encoded lam

   CAMAC_TEST           Include camac routines which can be called
                        interactively from the VxWorks shell
*/

/*------------------------------------------------------------------*/

#define CAMO(n,a,f,d) (d)
#define CAMI(n,a,f,d) *(d) = 1
#define CAMI24(n,a,f,d) *(d) = 1
#define CAMIQ(n,a,f,d,x,q)   { *(d) = 1; *x = 1; *q = 1; }
#define CAMIQ24(n,a,f,d,x,q) { *(d) = 1; *x = 1; *q = 1; }
#define CAMQ(n,a,f,q)        { *q = 1; }
#define CAML(d)              { *d = 1; }

#define CAMAC_INIT() 
#define CAMAC_SET_INHIBIT()
#define CAMAC_CLEAR_INHIBIT()
#define CAMAC_C_CYCLE()
#define CAMAC_Z_CYCLE()
#define CAMAC_LAM_ENABLE(n)
#define CAMAC_LAM_RESET()

/*------------------------------------------------------------------*/

#define CAMAC_TEST void camo(n,a,f,d)  \
{ CAMO(n,a,f,d); }                     \
void cami(n,a,f) {                     \
  unsigned long d,x,q;                 \
  CAMIQ(n,a,f,&d,&x,&q);               \
  printf("d=%lX,X=%d,Q=%d\n",d,x,q); } \
void set_inhibit(void)                 \
{ *((unsigned long *) 0xC0E7A4) = 0; } \
void clear_inhibit(void)               \
{ *((unsigned long *) 0xC0C7A4) = 0; } \
void c_cycle(void)                     \
{ *((unsigned long *) 0xC0D724) = 0; } \
void z_cycle(void)                     \
{ *((unsigned long *) 0xC0D720) = 0; } 

/*------------------------------------------------------------------*/
